#ifndef _APPLICATION1_H_
#define _APPLICATION1_H_

#include <Application.h>
#include <OS.h>
#include <Window.h>
#include "Window1.h"
#include "Window2.h"
#include "Window5.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <Entry.h>
#include <Node.h>
#include <Path.h>
#include <NodeInfo.h>
#include <File.h>
#include <Directory.h>
#include <SymLink.h>
#include <Alert.h>
#include <StopWatch.h>
#include <scsi.h>
#include <CAM.h>
#include "MediaInfo.h"
#include <signal.h>
#include <Bitmap.h>
#include <FilePanel.h>
#include "ProtocolWindow.h"
#include "M3UList.h"
#include "StatusWindow.h"

#include "ConfigWindow.h"
#include "ConfigManager.h"
#include "HeliosConfigView.h"
#include "DeviceConfigView.h"
#include "PathConfigView.h"
#include "ImageConfigView.h"
#include "StandardConfigView.h"
#include "ApplicationConfigView.h"
#include "SaveConfigView.h"
#include "SoundConfigView.h"
#include "ColorConfigView.h"
#include "VersionConfigView.h"
#include "FSPanel.h"
#include "AudioWindow.h"


class Application1 : public BApplication {
public:
	Application1 ();
	~Application1 (void);


	virtual void ReadyToRun(void);
	virtual bool QuitRequested(void);
	virtual void MessageReceived(BMessage *message);
	virtual void RefsReceived(BMessage *message);
	virtual void AboutRequested(void);
	Window1 * window1;
	Window2 * window2;
	StatusWindow	*statusSW;
	Window5 * window5;
//	SettingsWindow *settingswindow;
	ConfigWindow		*configW;
	AudioWindow		*audioW;
	
	// this string contains a description of the last error occurred
	BString		errtype, errstring;

bool FileCopy(const char *source, const char *destination, size_t srcfilesize);
bool FileExists(BEntry *entry);
bool FileExists(BEntry entry);
bool FileExists(BFile *file);
bool FileExists(char *filename);
bool FileExists(const char *filename);
bool IsProject(bool show_alert);
	
status_t GetMultisessionSectors(int32 &start, int32 &end);
const char *CheckCommandlineTool(const char *fullpath, const char *name);
	
	
bool CreateEntry(char *pathname, char *entryname);
void ShowFolder(bool audio=false);
void Update_path();
status_t MakeImage();
bool OnlyFiles();
status_t BurnAudio(bool multisession);
status_t BurnCDExtra();
status_t BlankRW(char *mode);
bool GetImageSize();
void ChangePauses();
void Update_DATA_AUDIO();
void HideStatus();
void ShowStatus(const char *text);
status_t MakeImage_NOSTREAMING();
void ReadOutputOfCdrecord(int outstream, thread_id thread, int tracks=1);
void SetStatus(const char *text);
void MoveUp();
void MoveDown();
status_t BurnImage(BString filename);
status_t ReadImage(BString *filename, bool alloweject=true);
void HideStatus2();
void ShowStatus2(const char *text, thread_id Thread);
void SetStatus2(const char *text, thread_id Thread);
void SetStatus2Info(const char *text, const char *leading="");
status_t MakeImageOnly(const char *filename);
void eject_media(const char * dev);
void load_media(const char * dev);
status_t CopyOnTheFly();
status_t CopyOnTheFlyAudio();
status_t CopyAudioCD();
void DoAudioMenu();
void DoDataMenu();
void Calculate_time();
void GetFolder(BDirectory dir);
void UpdateTrackNumbers();
float ItemLength(BStringItem *item);
void SetPercentage(float percentage);
int DeviceStatus(const char *path);
status_t CopyDataCD();
int UnmountBFSImage(const char *mountpoint);
int MountBFSImage(const char *filename, const char *mountpoint);
void DeleteAllIn(BDirectory dir);
status_t WaitForDisc(const char *device);

void SaveSettings();
void ReadSettings();

void SetHelpBubbles();

const char *SuggestProjectName();
//void ShowOpenPanel();
//void ShowSavePanel();
//void ShowFolderPanel();
//void ShowExportPanel(BMessage *msg);

void LoadProject(BEntry *entry);
void SaveProject(BEntry *entry, bool export_project=false);
void NewProject();
void SetAsStandardProject();
void ExportAsM3U(BEntry *entry);
void ExportAsAPML(BEntry *entry);
void ExportAsFileList(BEntry *entry);
void GetEntryNamesIn(BDirectory dir, M3UList *list);
void AddToRecent(const char *filename);
void ShowRecentProjects();
void RefreshStatusView();

void RemoveInfFiles();
const char *GenerateInfFilename(int32 index);
void ExportAsInf(const char *filename, int32 index);
void SaveCDTEXTAlbum();
//int MakeMKISOFSCommandline(const char **args, const char *filename, bool printsize=false);

// bfs
status_t MakeBFSImage(const char *filename);

// mkisofs-file system
status_t MakeMKISOImage(const char *filename);

void GetSize(BDirectory dir);
void CheckIfProjectChanged();
bool CheckCDSize();

int ReadAudioCD();
size_t GetDeviceSize(const char *path);

void PopulateFoldersMenu();
void DeleteAndCount(BDirectory dir);

void PlayFinishedBurningSound();
void PlayFinishedImageSound();
void PlayErrorSound();

status_t	ReadFloppyImage(const char *path);
static int32 		addFiles(void *data);
static int32		removeFiles(void *data);
void SetWorking(bool state=true);

//void AddFileTrackNumbers();
//void RemoveFileTrackNumbers();

sem_id streambuffer_sem;
sem_id		fileadder_sem, fileremover_sem;



//settings_struct settings;


//struct projectStruct {
//	char	_currentpath[B_PATH_NAME_LENGTH];
//	char	_basepath[B_PATH_NAME_LENGTH];
//	int	_filesystem;		// menuitem index
//	char 	_volumename[64];
//	char 	_cdtype;		// 0 for data, 1 for audio
//	char	_publisher[128];
//	char	_preparer[128];
//	char	_application[128];
//	char	_itemBlocksFollowing;
//};
//
//struct audioBlock {
//	char	_cdtext_title[161];
//	float	_pause;
//	float	_indexList[99];
//	char	_filename[B_PATH_NAME_LENGTH];
//	size_t	_length;
//};

BMessage	listview_content,
		application_settings;

char donow;
//BFilePanel	*filepanel;
//BStringView	*filepanelSV;
BString		currentproject;
BString base_folder;
BString current_folder;
BString cdir;
BString pathdisplay;
long imagesize;
BStopWatch *watch;
bool addershows;
int number;

off_t imgsize;
int32 files, directories;
//ToolTip *tooltip1, *tooltip2;
//BBitmap *bmp;

int32 filename_col;
bool save_and_quit;
bool is_all_showing;
bool just_quit;
size_t	cdextra_datasize;

int32 filecounter;

typedef struct track_info {
	char	type[32];
	int		size;
} track_info;

ProtocolWindow	*cdrecord_output,
			*mkisofs_output;

ConfigManager	*CM;
HeliosConfigView	*heliosCV;
DeviceConfigView	*deviceCV;
PathConfigView	*pathCV;
ImageConfigView	*imageCV;
StandardConfigView	*standardCV;
ApplicationConfigView *applicationCV;
SaveConfigView	*saveCV;
SoundConfigView	*soundCV;
ColorConfigView	*colorCV;
VersionConfigView	*versionCV;
FSPanel		*fspanelCV;

};

#endif
