#include "AudioCDPanel.h"
#include "HLM.h"

#define CDTEXTBOX_MSG 'AP01'

extern HLM *H;

AudioCDPanel::AudioCDPanel(BRect frame):BView(frame, "AudioCDPanel", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW) {
	cdtextCB=new BCheckBox(BRect(frame.left+4, frame.top, frame.right-4, frame.top+16), "acdp_writeCDText", H->L("TWRITECDTEXT"), new BMessage(CDTEXTBOX_MSG));
	copyprotectionCB=new BCheckBox(BRect(frame.left+4, frame.top, frame.right-4, frame.top+16), "acdp_copyprotection", H->L("TCOPYPROTECTION"), NULL);
	CDTextAlbum=new BTextControl(BRect(frame.left+4, frame.top, frame.right-4, frame.top+16), "acdp_cdtextalbum", H->L("TCDTEXTALBUMLABEL"), "", NULL);
	AddChild(copyprotectionCB);
	AddChild(cdtextCB);
	AddChild(CDTextAlbum);
	SetViewColor((rgb_color){216,216,216,255});
}

AudioCDPanel::~AudioCDPanel() {
	delete cdtextCB;
	delete copyprotectionCB;
	delete CDTextAlbum;
}

void AudioCDPanel::AllAttached() {
	copyprotectionCB->MoveTo(5,7);
	copyprotectionCB->ResizeTo(22+StringWidth(copyprotectionCB->Label()), 16);
	cdtextCB->MoveTo(5,28);
	cdtextCB->ResizeTo(22+StringWidth(cdtextCB->Label()), 16);
	
	CDTextAlbum->MoveTo(5, 53);
	CDTextAlbum->ResizeTo(200, 20);
	// initializes the textcontrol with the previously loaded user-settings
	CDTextAlbum->SetDivider(StringWidth(H->L("TVOLUMENAME"))+28);
	CDTextAlbum->SetEnabled(cdtextCB->Value()==B_CONTROL_ON);
	cdtextCB->SetTarget(this);
}

void AudioCDPanel::MessageReceived(BMessage *msg) {
	switch(msg->what) {
		case CDTEXTBOX_MSG:
			CDTextAlbum->SetEnabled(cdtextCB->Value()==B_CONTROL_ON);
			break;
			
		default:
			BView::MessageReceived(msg);
			break;
	}
}

bool AudioCDPanel::writeCDText() {
	return (cdtextCB->Value()==B_CONTROL_ON);
}

void AudioCDPanel::SetCDText(bool flag) {
	if (flag)  	cdtextCB->SetValue(B_CONTROL_ON); else
			cdtextCB->SetValue(B_CONTROL_OFF);
}

bool AudioCDPanel::copyProtection() {
	return (copyprotectionCB->Value()==B_CONTROL_ON);
}

void AudioCDPanel::SetProtection(bool flag) {
	if (flag)  	copyprotectionCB->SetValue(B_CONTROL_ON); else
			copyprotectionCB->SetValue(B_CONTROL_OFF);
}

void AudioCDPanel::SetCDAlbum(const char *name) {
	CDTextAlbum->SetText(name);
}

const char *AudioCDPanel::GetCDAlbum() {
	return CDTextAlbum->Text();
}
