#include "BrowseControl.h"

#define BROWSEBUTTON_MSG	'BC00'

BrowseControl::BrowseControl(BRect frame, const char *name, const char *label, const char *buttonLabel,
		const char *text, uint32 resizingMode, uint32 flags=B_WILL_DRAW, BMessage *message=NULL)
		: BView(frame, name, resizingMode, flags) {
		
	// Add Browse-Button
	browseB=new BButton(BRect(frame.Width()-70, 0, frame.Width(), frame.Height()), "browseB", buttonLabel, new BMessage(BROWSEBUTTON_MSG), B_FOLLOW_RIGHT | B_FOLLOW_TOP_BOTTOM);
	AddChild(browseB);

	// Add Textcontrol
	textTC=new BTextControl(BRect(0, 0, frame.Width()-71, frame.Height()), "textTC", label, text, message, B_FOLLOW_LEFT_RIGHT | B_FOLLOW_TOP_BOTTOM);
	AddChild(textTC);
	
	// Create FilePanel
	filepanelFP=new BFilePanel();
}

BrowseControl::~BrowseControl(){
}

BTextControl	*BrowseControl::GetTextControl() {
	return textTC;
}

void	BrowseControl::SetFilePanel(BFilePanel *panel) {
	filepanelFP=panel;
}

//
// PRIVATE MEMBER FUNCTIONS
//

void	BrowseControl::AttachedToWindow() {
	textTC->SetTarget(this);
	browseB->SetTarget(this->Window());
}

void	BrowseControl::MessageReceived(BMessage *msg) {
	switch(msg->what) {
		case BROWSEBUTTON_MSG: {
			break;
		}
		default: {
			BView::MessageReceived(msg);
			break;
		}
	}
}



