#include "ImageConfigView.h"
#include "HLM.h"

extern HLM *H;

ImageConfigView::ImageConfigView() : ConfigView(){
	BFont *TCfont=new BFont(be_fixed_font);
	TCfont->SetSize(10.0);

	// TEXTCONTROLS
	publisherTC=new BTextControl(BRect(15,8,340,33),"icv_publisherTC",H->L("TPUBLISHER"), "",NULL);
	publisherTC->SetDivider(publisherTC->StringWidth(H->L("TPUBLISHER"))+5);
	publisherTC->TextView()->SetMaxBytes(128);
	publisherTC->TextView()->SetFontAndColor(TCfont);
	AddChild(publisherTC);

	preparerTC=new BTextControl(BRect(15,38,340,63),"icv_preparerTC",H->L("TPREPARER"), "",NULL);
	preparerTC->SetDivider(preparerTC->StringWidth(H->L("TPREPARER"))+5);
	preparerTC->TextView()->SetMaxBytes(128);
	preparerTC->TextView()->SetFontAndColor(TCfont);
	AddChild(preparerTC);

	applicationTC=new BTextControl(BRect(15,68,340,93),"icv_applicationTC",H->L("TAPPLICATION"), "",NULL);
	applicationTC->SetDivider(applicationTC->StringWidth(H->L("TAPPLICATION"))+5);
	applicationTC->TextView()->SetMaxBytes(128);
	applicationTC->TextView()->SetFontAndColor(TCfont);
	AddChild(applicationTC);
}

ImageConfigView::~ImageConfigView() {
}

const char *ImageConfigView::GetPublisher() {
	return publisherTC->Text();
}

void ImageConfigView::SetPublisher(const char *str) {
	publisherTC->SetText(str);
}

const char *ImageConfigView::GetPreparer() {
	return preparerTC->Text();
}

void ImageConfigView::SetPreparer(const char *str) {
	preparerTC->SetText(str);
}

const char *ImageConfigView::GetApplication() {
	return applicationTC->Text();
}

void ImageConfigView::SetApplication(const char *str) {
	applicationTC->SetText(str);
}

// PRIVATE

void	ImageConfigView::MessageReceived(BMessage *msg) {
	switch(msg->what) {
		default: {
			BView::MessageReceived(msg);
			break;
		}
	}
}