#ifndef _BMEDIASLIDER_H_
#define _BMEDIASLIDER_H_

#include <InterfaceKit.h>

class BMediaSlider : public BView {
	public:
		BMediaSlider(BRect frame,
			const char *name,
			bigtime_t duration,
			BMessage *downMessage,
			BMessage *dragMessage,
			BMessage *upMessage,
			uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP);
		~BMediaSlider();
	
		void	SetCurrentTime(bigtime_t);
	
		virtual void Draw(BRect updateRect);
		virtual void MouseDown(BPoint point);
		virtual void MouseMoved(BPoint point, uint32 transit, const BMessage *message);
		virtual void MouseUp(BPoint point);
		
	private:
		BRect 			GetLeftRect();
		BRect 			GetRightRect();
		BRect 			GetBodyRect();
		
		void			DrawLeft();
		
		
		bigtime_t		fCurrentTime;
		bigtime_t		fTotalTime;
		BBitmap		*fLeftBM,
					*fRightBM,
					*fBodyBM;
};


#endif

