#include "PathConfigView.h"
#include "HLM.h"
#include <stdio.h>
#include <Directory.h>

#define PROJECTPATH_CHANGED	'PCV0'
#define TEMPPATH_CHANGED		'PCV1'

extern HLM *H;

PathConfigView::PathConfigView() : ConfigView(){
	// TEXTCONTROLS
	projectpathTC=new BrowseField(BRect(15,5,340,30),"pcv_projectpathTC");//,H->L("TPROJECTPATH"), "", new BMessage(PROJECTPATH_CHANGED));
	projectpathTC->GetTextControl()->SetDivider(projectpathTC->StringWidth(H->L("TPROJECTPATH"))+5);
	projectpathTC->GetButton()->SetLabel(H->L("TBROWSE"));
	projectpathTC->Init(H->L("C_SELECT"), NULL, B_FILE_NODE|B_DIRECTORY_NODE);
	projectpathTC->GetTextControl()->SetLabel(H->L("TPROJECTPATH"));
	projectpathTC->GetTextControl()->TextView()->SetMaxBytes(8192);
	AddChild(projectpathTC);

	temppathTC=new BrowseField(BRect(15,35,340,60),"pcv_temppathTC");//,H->L("TTEMPPATH"), "", new BMessage(TEMPPATH_CHANGED));
	temppathTC->GetTextControl()->SetDivider(temppathTC->StringWidth(H->L("TTEMPPATH"))+5);
	temppathTC->GetButton()->SetLabel(H->L("TBROWSE"));
	temppathTC->Init(H->L("C_SELECT"), NULL, B_FILE_NODE|B_DIRECTORY_NODE);
	temppathTC->GetTextControl()->SetLabel(H->L("TTEMPPATH"));
	temppathTC->GetTextControl()->TextView()->SetMaxBytes(8192);
	AddChild(temppathTC);

	imagenameTC=new BrowseField(BRect(15,65,340,90),"pcv_imagenameTC");//,H->L("TDEFAULTIMAGENAME"), "",NULL);
	imagenameTC->GetTextControl()->SetDivider(imagenameTC->StringWidth(H->L("TDEFAULTIMAGENAME"))+5);
	imagenameTC->GetButton()->SetLabel(H->L("TBROWSE"));
	imagenameTC->GetButton()->Hide();
	imagenameTC->Init(H->L("C_SELECT"), NULL, B_FILE_NODE);
	imagenameTC->GetTextControl()->SetLabel(H->L("TDEFAULTIMAGENAME"));
	imagenameTC->GetTextControl()->TextView()->SetMaxBytes(8192);
	AddChild(imagenameTC);

	mountpointTC=new BrowseField(BRect(15,95,340,120),"pcv_mountpointTC");//,H->L("TDEFAULTMOUNTPOINT"), "",NULL);
	mountpointTC->GetTextControl()->SetDivider(mountpointTC->StringWidth(H->L("TDEFAULTMOUNTPOINT"))+5);
	mountpointTC->GetButton()->SetLabel(H->L("TBROWSE"));
	mountpointTC->Init(H->L("C_SELECT"), NULL, B_FILE_NODE|B_DIRECTORY_NODE);
	mountpointTC->GetTextControl()->SetLabel(H->L("TDEFAULTMOUNTPOINT"));
	mountpointTC->GetTextControl()->TextView()->SetMaxBytes(8192);
	AddChild(mountpointTC);
}

PathConfigView::~PathConfigView() {
}

const char *PathConfigView::GetTemporaryPath() {
	return temppathTC->GetTextControl()->Text();
}

void PathConfigView::SetTemporaryPath(const char *path) {
	temppathTC->GetTextControl()->SetText(path);
}
	
const char *PathConfigView::GetProjectPath() {
	//printf("Project Path: %s\n", projectpathTC->GetTextControl()->Text());
	return projectpathTC->GetTextControl()->Text();
}

void PathConfigView::SetProjectPath(const char *path) {
	projectpathTC->GetTextControl()->SetText(path);
}

const char *PathConfigView::GetDefaultImageName() {
	return imagenameTC->GetTextControl()->Text();
}

void PathConfigView::SetDefaultImageName(const char *path) {
	imagenameTC->GetTextControl()->SetText(path);
}

const char *PathConfigView::GetDefaultMountPoint() {
	return mountpointTC->GetTextControl()->Text();
}

void PathConfigView::SetDefaultMountPoint(const char *path) {
	mountpointTC->GetTextControl()->SetText(path);
}

// PRIVATE

void 	PathConfigView::AllAttached() {
	//projectpathTC->GetTextControl()->SetTarget(this);
	//temppathTC->GetTextControl()->SetTarget(this);
	ConfigView::AllAttached();
}

void	PathConfigView::MessageReceived(BMessage *msg) {
	switch(msg->what) {
	/*	case PROJECTPATH_CHANGED: {
			BString		bf=GetProjectPath();

			if (bf[bf.Length()-1]=='/')
				bf.RemoveLast("/");
			
			bf.Append("/");

			create_directory(bf.String(), 0777);
		}

		case TEMPPATH_CHANGED: {
			BString		bf=GetTemporaryPath();

			if (bf[bf.Length()-1]=='/')
				bf.RemoveLast("/");
				
			bf.Append("/");

			create_directory(bf.String(), 0777);
		}
*/
		default: {
			BView::MessageReceived(msg);
			break;
		}
	}
}