#ifndef _STATUSVIEW_H_
#define _STATUSVIEW_H_

#include <View.h>
#include "ColumnListView.h"
#include <Rect.h>
#include <Font.h>
#include <PopUpMenu.h>
#include <MenuItem.h>
#include <Bitmap.h>

class StatusView : public BView {
public:
	StatusView(BColumnListView *owner);
		~StatusView();
	
	virtual void	Draw(BRect updateRect);
	virtual void	MouseDown(BPoint point);
	
	void 			SetNumberOfItems(int32 number);
	void			AddMenuItem(BMenuItem *item);
	void			RemoveMenuItems();
	
protected:
	void			DrawPressed(BBitmap *bm, BRect *rect);
		
private:
	BColumnListView	*fowner;
	BFont			font;
	char 			*itemString;
	BPopUpMenu		*menuPOP;
	BRect			newfolderRect,
				contextRect,
				trashRect;
	BBitmap		*newfolderBM,
				*trashBM;
	bool			trashPressed;
};

#endif
