#include "VersionControl.h"

VersionControl::VersionControl(BRect frame, const char *name, uint32 resizingMode, uint32 flags)
		: BView(frame, name, resizingMode, flags) {

	fIcon=new BBitmap(BRect(0,0,15,15), B_CMAP8);
	fString=new BString();
	SetViewColor(216,216,216);
	SetFont(be_plain_font);
	SetFontSize(10);
}

VersionControl::~VersionControl() {
	if (fIcon)
		delete fIcon;
	delete fString;
}

void	VersionControl::SetIcon(BBitmap *icon) {
	if (fIcon)
		delete fIcon;
	fIcon=icon;
	Draw(Bounds());
}

void	VersionControl::SetText(const char *text) {
	fString->SetTo(text);
	Draw(Bounds());
}


void	VersionControl::Draw(BRect updateRect) {
	SetDrawingMode(B_OP_OVER);
	DrawBitmap(fIcon, BPoint(0,0));
	MovePenTo(fIcon->Bounds().Width()+5, Bounds().Height()-4);
	SetHighColor(0,0,0);
	SetLowColor(255,255,255);
	DrawString(fString->String());
	BView::Draw(updateRect);
}








